package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetUniverseConstellationsConstellationIDParams creates a new GetUniverseConstellationsConstellationIDParams object
// with the default values initialized.
func NewGetUniverseConstellationsConstellationIDParams() *GetUniverseConstellationsConstellationIDParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseConstellationsConstellationIDParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetUniverseConstellationsConstellationIDParamsWithTimeout creates a new GetUniverseConstellationsConstellationIDParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetUniverseConstellationsConstellationIDParamsWithTimeout(timeout time.Duration) *GetUniverseConstellationsConstellationIDParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseConstellationsConstellationIDParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		timeout: timeout,
	}
}

// NewGetUniverseConstellationsConstellationIDParamsWithContext creates a new GetUniverseConstellationsConstellationIDParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetUniverseConstellationsConstellationIDParamsWithContext(ctx context.Context) *GetUniverseConstellationsConstellationIDParams {
	var (
		datasourceDefault = string("tranquility")
		languageDefault   = string("en-us")
	)
	return &GetUniverseConstellationsConstellationIDParams{
		Datasource: &datasourceDefault,
		Language:   &languageDefault,

		Context: ctx,
	}
}

/*GetUniverseConstellationsConstellationIDParams contains all the parameters to send to the API endpoint
for the get universe constellations constellation id operation typically these are written to a http.Request
*/
type GetUniverseConstellationsConstellationIDParams struct {

	/*ConstellationID
	  constellation_id integer

	*/
	ConstellationID int32
	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string
	/*Language
	  Language to use in the response

	*/
	Language *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get universe constellations constellation id params
func (o *GetUniverseConstellationsConstellationIDParams) WithTimeout(timeout time.Duration) *GetUniverseConstellationsConstellationIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get universe constellations constellation id params
func (o *GetUniverseConstellationsConstellationIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get universe constellations constellation id params
func (o *GetUniverseConstellationsConstellationIDParams) WithContext(ctx context.Context) *GetUniverseConstellationsConstellationIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get universe constellations constellation id params
func (o *GetUniverseConstellationsConstellationIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithConstellationID adds the constellationID to the get universe constellations constellation id params
func (o *GetUniverseConstellationsConstellationIDParams) WithConstellationID(constellationID int32) *GetUniverseConstellationsConstellationIDParams {
	o.SetConstellationID(constellationID)
	return o
}

// SetConstellationID adds the constellationId to the get universe constellations constellation id params
func (o *GetUniverseConstellationsConstellationIDParams) SetConstellationID(constellationID int32) {
	o.ConstellationID = constellationID
}

// WithDatasource adds the datasource to the get universe constellations constellation id params
func (o *GetUniverseConstellationsConstellationIDParams) WithDatasource(datasource *string) *GetUniverseConstellationsConstellationIDParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get universe constellations constellation id params
func (o *GetUniverseConstellationsConstellationIDParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WithLanguage adds the language to the get universe constellations constellation id params
func (o *GetUniverseConstellationsConstellationIDParams) WithLanguage(language *string) *GetUniverseConstellationsConstellationIDParams {
	o.SetLanguage(language)
	return o
}

// SetLanguage adds the language to the get universe constellations constellation id params
func (o *GetUniverseConstellationsConstellationIDParams) SetLanguage(language *string) {
	o.Language = language
}

// WriteToRequest writes these params to a swagger request
func (o *GetUniverseConstellationsConstellationIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	// path param constellation_id
	if err := r.SetPathParam("constellation_id", swag.FormatInt32(o.ConstellationID)); err != nil {
		return err
	}

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if o.Language != nil {

		// query param language
		var qrLanguage string
		if o.Language != nil {
			qrLanguage = *o.Language
		}
		qLanguage := qrLanguage
		if qLanguage != "" {
			if err := r.SetQueryParam("language", qLanguage); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
