package universe

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetUniverseConstellationsParams creates a new GetUniverseConstellationsParams object
// with the default values initialized.
func NewGetUniverseConstellationsParams() *GetUniverseConstellationsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseConstellationsParams{
		Datasource: &datasourceDefault,

		timeout: cr.DefaultTimeout,
	}
}

// NewGetUniverseConstellationsParamsWithTimeout creates a new GetUniverseConstellationsParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetUniverseConstellationsParamsWithTimeout(timeout time.Duration) *GetUniverseConstellationsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseConstellationsParams{
		Datasource: &datasourceDefault,

		timeout: timeout,
	}
}

// NewGetUniverseConstellationsParamsWithContext creates a new GetUniverseConstellationsParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetUniverseConstellationsParamsWithContext(ctx context.Context) *GetUniverseConstellationsParams {
	var (
		datasourceDefault = string("tranquility")
	)
	return &GetUniverseConstellationsParams{
		Datasource: &datasourceDefault,

		Context: ctx,
	}
}

/*GetUniverseConstellationsParams contains all the parameters to send to the API endpoint
for the get universe constellations operation typically these are written to a http.Request
*/
type GetUniverseConstellationsParams struct {

	/*Datasource
	  The server name you would like data from

	*/
	Datasource *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get universe constellations params
func (o *GetUniverseConstellationsParams) WithTimeout(timeout time.Duration) *GetUniverseConstellationsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get universe constellations params
func (o *GetUniverseConstellationsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get universe constellations params
func (o *GetUniverseConstellationsParams) WithContext(ctx context.Context) *GetUniverseConstellationsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get universe constellations params
func (o *GetUniverseConstellationsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithDatasource adds the datasource to the get universe constellations params
func (o *GetUniverseConstellationsParams) WithDatasource(datasource *string) *GetUniverseConstellationsParams {
	o.SetDatasource(datasource)
	return o
}

// SetDatasource adds the datasource to the get universe constellations params
func (o *GetUniverseConstellationsParams) SetDatasource(datasource *string) {
	o.Datasource = datasource
}

// WriteToRequest writes these params to a swagger request
func (o *GetUniverseConstellationsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	if o.Datasource != nil {

		// query param datasource
		var qrDatasource string
		if o.Datasource != nil {
			qrDatasource = *o.Datasource
		}
		qDatasource := qrDatasource
		if qDatasource != "" {
			if err := r.SetQueryParam("datasource", qDatasource); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
